/*
 * myfile.js
 *
 *  Created on: 08.02.2016
 *      Author: Holger Dahm
 *
 *  Note: normally no change in this file is necessary - it's generic
 */

// initialize optionscontroller
var optionscontroller = require("./optionscontroller");
// initialize appcontroller for
// json or xml request, caching as well as message to pebble send operations
var appcontroller = require("./libs/appcontroller");
// initialize infoproviders
var infoproviders = require("./infoproviders/infoproviders");



/*
 * send options/ cached informations to pebble
 */

function start() {
	optionscontroller.pushOptionsToAppmessageQueue();

    // test if cached informations are available; in case push it to app message queue
	if (!optionscontroller.isLicenceExpired()) {
		infoproviders.pushCachedInfosToAppmessageQueue();
	}

    appcontroller.sendAppMessage(true);
}

/*
 * clear options/ cached informations
 */

function clearCache() {
    console.log('RESET LOCAL STORAGE - ALL PROPERTIES!!!!!!!!!!!!');

    optionscontroller.clearCache();
    infoproviders.clearCache();
}

/*
 * pebble event listeners
 */

Pebble.addEventListener("ready",
    function(event) {
        // start processing; flag is unset in sendAppMessage if last element of queue was send
		appcontroller.setProcessing(true);

		// ensure that app controller is available
		optionscontroller.setAppController(appcontroller);
	    infoproviders.setAppController(appcontroller);

        //clearCache();
	    optionscontroller.initialize(infoproviders);              // set default values
        optionscontroller.getRemoteOptions(infoproviders, start); // tries to request JSON options,
                                                                  // sets options in appcontroller as well as infoproviders and
                                                                  // finally calls start(); which in turn unsets processing = true ;)
    }
);

Pebble.addEventListener('showConfiguration',
    function(event) {
        Pebble.openURL(optionscontroller.getSettingsURL());
    }
);

Pebble.addEventListener('webviewclosed',
    function(event) {
        if (event.response) {
        	optionscontroller.setOptions(JSON.parse(decodeURIComponent(event.response)), infoproviders);

            start();
        }
    }
);

Pebble.addEventListener("appmessage", infoproviders.processPebbleRequest);
